package progressroundbuttonwrapper;

import main.java.com.xiaochen.progressroundbutton.AnimDownloadProgressButton;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;


import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.support.annotation.NonNull;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;
import android.widget.ListAdapter;
import android.widget.ListView;
import java.util.List;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("ProgressRoundButton")
@DependsOn(values={"android-support-v4"})
public class progressRoundButtonWrapper extends TextViewWrapper<AnimDownloadProgressButton> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private AnimDownloadProgressButton cv;
	
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new AnimDownloadProgressButton(ba.context, null);
                this.setObject(cv);
                addListener();
 	}




//    @Hide
//    public void addListener(){
//        cv.setCallback(new NiceSpinner.Callback() {
////            @Override
//            public void item_clicked() {

//              if (ba.subExists(eventName + "_item_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_item_clicked", true, new Object[0]);
//              }
//            }

//            @Override
//            public void bottom_clicked() {
//
//              if (ba.subExists(eventName + "_bottom_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_bottom_clicked", true, new Object[0]);
//              }
//            }

//        });
//    }


      @Hide
      public void addListener(){
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
              if (ba.subExists(eventName + "_button_clicked")) {
                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
              }
            }
        });
      }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    public int getState() {
        return cv.getState();
    }

    public void setState(int state) {
        cv.setState(state); 
        cv.invalidate();
    }

    public void setCurrentText(CharSequence charSequence) {
        cv.setCurrentText(charSequence);
        cv.invalidate();
    }


    public void setProgressText(String text, float progress) {
        cv.setProgressText(text, progress);
        cv.invalidate();
    }

    public float getProgress() {
        return cv.getProgress();
    }

    public void setProgress(float progress) {
        cv.setProgress(progress);
        cv.invalidate();
    }

    public float getButtonRadius() {
        return cv.getButtonRadius();
    }

    public void setButtonRadius(float buttonRadius) {
        cv.setButtonRadius(buttonRadius);
        cv.invalidate();
    }

    public int getTextColor() {
        return cv.getTextColor();
    }


    public void setTextColor(int textColor) {
        cv.setTextColor(textColor);
        cv.invalidate();
    }

    public int getTextCoverColor() {
        return cv.getTextCoverColor();
    }

    public void setTextCoverColor(int textCoverColor) {
        cv.setTextCoverColor(textCoverColor);
        cv.invalidate();
    }

    public int getMinProgress() {
        return cv.getMinProgress();
    }

    public void setMinProgress(int minProgress) {
        cv.setMinProgress(minProgress);
        cv.invalidate();
    }

    public int getMaxProgress() {
        return cv.getMaxProgress();
    }

    public void setMaxProgress(int maxProgress) {
        cv.setMaxProgress(maxProgress);
        cv.invalidate();
    }

    public void setTheTextSize(float textsize){
        cv.setTheTextSize(textsize);
    }

    public void setBackgroundColor(int mBackgroundColor){
        cv.setBackgroundColor(mBackgroundColor);
        cv.invalidate();
    }

    public void setBackgroundSecondColor(int mBackgroundSecondColor){
        cv.setBackgroundSecondColor(mBackgroundSecondColor);
        cv.invalidate();
    }





}
